﻿<%@ WebHandler Language="C#" Class="Handler" %>

using System;
using System.Web;
using ASPNetSpell;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using System.Text;

public class Handler : IHttpHandler {

    public void ProcessRequest(HttpContext context)
    {

        string LicenceKey = "TRIAL";
        
        
        
        
        
        
        string command = "";
        
        HttpResponse r = context.Response;
        HttpRequest req = context.Request;
        
        if (req.Form["command"] != null)
        {
            command = req.Form["command"].ToUpper().Trim();
        }
        else
        {
            r.Write("No Command");
            r.End();
        }
        
        
     
        /// SETTINGS FILE///////////////
        ASPNetSpell.SpellChecker SpellEngine = new ASPNetSpell.SpellChecker();
        string localDictPath = req.MapPath("../dictionaries");
        SpellEngine.DictionaryPath = (localDictPath);
        
        if (LicenceKey != "TRAIL") { SpellEngine.LicenceKey = LicenceKey; }
        SpellEngine.IgnoreAllCaps = false;
        SpellEngine.IgnoreNumeric = false;
        SpellEngine.CaseSensitive = true;
        SpellEngine.LoadCustomDictionary("custom.txt");
        SpellEngine.LoadCustomBannedWords("language-rules/banned-words.txt");
        SpellEngine.LoadEnforcedCorrections("language-rules/enforced-corrections.txt");
        SpellEngine.LoadCommonTypos("language-rules/common-mistakes.txt");
        ////////////////////////////////
        
       
       
        r.BufferOutput = true;
        r.Buffer = true;
        r.ContentType = "text/plain";

        string lang = "English (International)";
       
        string note = "";
        bool script = false;
       
        string sender = "";
        string args = "";

     

        if (req.Form["args"] != null) { args = req.Form["args"]; }
        if (req.Form["lan"] != null) { lang = req.Form["lan"]; }
        if (req.Form["note"] != null) { note = req.Form["note"]; }
        if (req.Form["sender"] != null) { sender = req.Form["sender"]; }
        if (req.Form["script"] != null) { script = true; }


        




        

        string[] Langs = lang.Split(',');
        foreach (string dict in Langs)
        {
            SpellEngine.LoadDictionary(dict.Trim());
        }


       
        
        
        
        
        char chr1 = (char)1;
        char chr2 = (char)2;
        char chr5 = (char)5;
        string dlimit1 = new String(chr1, 1);
        string dlimit2 = new String(chr2, 1);
        string dlimit5 = new String(chr5, 1);


         if (command == "WINSETUP")
        {

            string[] words = args.Split(chr1);
            int suggestcountinit = 5;

            string[] error_type_words = new string[words.Length];
            string[] spell_check_words = new string[words.Length];
            string[] suggest_words = new string[words.Length];


            int maxsuglength = 0;
            int suggestcount = 0;

            for (int i = 0; i < words.Length; i++)
            {
                error_type_words[i] = "-";
                if (suggestcount < suggestcountinit + 1)
                {
                    suggest_words[i] = "";
                }

                spell_check_words[i] = SpellEngine.SpellCheckWord(words[i]) ? "T" : "F";


                if (spell_check_words[i] == "F")
                {
                    error_type_words[i] = SpellEngine.ErrorTypeWord(words[i]).ToString();


                    if (suggestcount < suggestcountinit + 1)
                    {
                        suggestcount++;

                        string a = words[i];


                        suggest_words[i] = String.Join(dlimit2, SpellEngine.Suggestions(words[i]));
                        maxsuglength = i;
                    }

                }
            }
            Array.Resize<string>(ref suggest_words, maxsuglength);

            r.Write("WINSETUP");
            r.Write(dlimit5);
            r.Write(sender);
            r.Write(dlimit5);
            r.Write(String.Join("", spell_check_words));
            r.Write(dlimit5);
            r.Write(String.Join(dlimit1, error_type_words));
            r.Write(dlimit5);
            r.Write(String.Join(dlimit1, suggest_words));
            r.Write(dlimit5);
            r.Write(String.Join(dlimit2, SpellEngine.ListDictionaries()));




        }

        if (command == "WINSUGGEST")
        {

            string[] words = args.Split(chr1);
            string[] suggest_words = new string[words.Length];


            for (int i = 0; i < words.Length; i++)
            {
                suggest_words[i] = String.Join(dlimit2, SpellEngine.Suggestions(words[i]));
            }


            r.Write("WINSUGGEST");
            r.Write(dlimit5);
            r.Write(sender);
            r.Write(dlimit5);
            r.Write(String.Join(dlimit1, suggest_words));
            
        }
        if (command == "CTXSPELL")
        {

            string[] words = args.Split(chr1);


            string[] error_type_words = new string[words.Length];
            string[] spell_check_words = new string[words.Length];
            string[] suggest_words = new string[words.Length];


            for (int i = 0; i < words.Length; i++)
            {



                spell_check_words[i] = SpellEngine.SpellCheckWord(words[i]) ? "T" : "F";

                error_type_words[i] = "-";
                if (spell_check_words[i] == "F")
                {
                    error_type_words[i] = SpellEngine.ErrorTypeWord(words[i]).ToString();
                }

            }






            r.Write("CTXSPELL");
            r.Write(dlimit5);
            r.Write(sender);
            r.Write(dlimit5);
            r.Write(String.Join("", spell_check_words));
            r.Write(dlimit5);
            r.Write(String.Join("" , error_type_words));


        }

        if (command == "CTXSUGGEST")
        {

            HttpContext.Current.Application["hello"]="Hello";
            


            r.Write("CTXSUGGEST");
            r.Write(dlimit5);
            r.Write(sender);
            r.Write(dlimit5);
            r.Write(String.Join(dlimit2, SpellEngine.Suggestions(args)));
   

            if (note.ToUpper() == "ADDLANGS")
            {
                r.Write(dlimit5);
                r.Write(String.Join(dlimit2, SpellEngine.ListDictionaries()));
            }
        }
        
        
        if (command == "RAWSPELL")
        {
            string word = args;
            bool ok = SpellEngine.SpellCheckWord(word);

            r.Write("RAWSPELL");
            r.Write(dlimit5);
            r.Write(sender);
            r.Write(dlimit5);
            r.Write(word);
            r.Write(dlimit5);
            r.Write(ok?"T":"F");
            r.Write(dlimit5);
            
            if(ok){
           
			r.Write(word);
			r.Write(dlimit5);
			}else{
			    r.Write(String.Join(dlimit2, SpellEngine.Suggestions(word)));
			    r.Write(dlimit5);
                r.Write(new String(SpellEngine.ErrorTypeWord(word),1));
		
            }
	    }
        
    if( command=="APISPELL"  || command=="APISPELLARRAY"   ){
	
     string[] words = args.Split(chr1);
	bool doSuggest  = (note!="NOSUGGEST");

    string[] error_type_words = new string[words.Length];
            string[] spell_check_words = new string[words.Length];
            string[] suggest_words = new string[words.Length];
	
	for(int i=0;i<words.Length;i++){
	
	  
	
		spell_check_words[i] = SpellEngine.SpellCheckWord( words[i])?"T":"F";	
				
				
		if(spell_check_words[i]=="F"){
		error_type_words[i] =  SpellEngine.ErrorTypeWord( words[i]).ToString();
			
		
		if(doSuggest){
			suggest_words[i]=String.Join(dlimit2, SpellEngine.Suggestions(words[i]));
		}else{
				suggest_words[i]="";
			}
			
		}
	}
        
           r.Write(command);
            r.Write(dlimit5);
            r.Write(sender);
              r.Write(dlimit5);
           
		     r.Write(String.Join("", spell_check_words));
            r.Write(dlimit5);
            r.Write(String.Join(dlimit1, error_type_words));
            r.Write(dlimit5);
            r.Write(String.Join(dlimit1, suggest_words));
            r.Write(dlimit5);
	        r.Write(String.Join(dlimit1, words));
		

	}    if(command=="APIDYM" ){
         r.Write("APIDYM");
		 r.Write(dlimit5);
         r.Write(sender);
         r.Write(dlimit5);
         r.Write(args);
         r.Write(dlimit5);
         r.Write(SpellEngine.DidYouMean(args));
         r.Write(dlimit5);
         r.Write(lang);
		
		}

    if (script) { 
    r.Write("<script type=\"text/javascript\">window.parent.livespell.ajax.pickupIframe(document.body.innerHTML)</script>");
    }
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}